require 'active_support/core_ext/numeric/time'

class FbDuration
  DURATION_LETTER_TO_METHOD = {
    'm' => :minutes,
    'd' => :days,
    'h' => :hours,
    'w' => :weeks,
    'y' => :years
  }.freeze

  DURATION_LETTER_TO_BEGINNING_OF_METHOD = {
    'm' => :beginning_of_minute,
    'd' => :beginning_of_day,
    'h' => :beginning_of_hour,
    'w' => :beginning_of_week,
    'y' => :beginning_of_year
  }.freeze

  def self.parse_to_time(facebook_format_duration)
    duration = parse(facebook_format_duration)
    time_to_beginning_of_duration_letter(Time.now - duration, facebook_format_duration)
  end

  def self.parse(facebook_format_duration)
    segments = facebook_format_duration.split

    segments[0].to_i.send(DURATION_LETTER_TO_METHOD[segments[1]])
  end

  def self.time_to_beginning_of_duration_letter(time, facebook_format_duration)
    duration_letter = facebook_format_duration.split[1]

    time.send(DURATION_LETTER_TO_BEGINNING_OF_METHOD[duration_letter])
  end
end
